import smtplib
from email.mime.text import MIMEText
from email.mime.image import MIMEImage
from email.mime.multipart import MIMEMultipart
from email.mime.application import MIMEApplication


class Mail:
    def sender(self,sender,password,toaddrs:list,title,content=None):
        self.sender = sender
        self.password = password
        self.toaddrs = toaddrs
        self.content = content
        self.textApart = MIMEText(self.content)
        self.m = MIMEMultipart()
        self.m['Subject'] = title

    def html(self,path,filename):
        filepath = path
        htmlApart = MIMEImage(open(filepath, 'rb').read(), filepath.split('.')[-1])
        htmlApart.add_header('Content-Disposition', 'attachment', filename=filename)
        self.m.attach(htmlApart)

        return htmlApart
    def universalFile(self,path,filename):
        pdfFile = path
        pdfApart = MIMEApplication(open(pdfFile, 'rb').read())
        pdfApart.add_header('Content-Disposition', 'attachment', filename=filename)
        self.m.attach(pdfApart)

    def smtp(self,smtp='smtp.163.com'):
        try:
            server = smtplib.SMTP(smtp)
            server.login(self.sender, self.password)
            server.sendmail(self.sender, self.toaddrs, self.m.as_string())
            print('success')
            server.quit()
        except smtplib.SMTPException as e:
            print('error:', e)  # 打印错误

class UnittestMail:
    e = Mail()
    e.sender('gfl13453001@163.com','gfl802300',['gfl13453001@163.com','13453001@qq.com'],"测试",'自动化测试')
    e.html(r'Z:\AutoFrame\report\TestReport\UI自动化测试报告.html','报告.html')
    e.universalFile(r'Z:\AutoFrame\report\TestReport\UI自动化测试报告.json','报告.json')
    e.smtp()


if __name__ == '__main__':
    UnittestMail()