import time,os
import logging.handlers

class Log(object):
    def __init__(self):
        # logging初始化工作
        try:
            logging.basicConfig()
            # myapp的初始化工作
            self.myapp = logging.getLogger('myapp')
            # 添加TimedRotatingFileHandler
            # 定义一个1秒换一次log文件的handler
            # 保留3个旧log文件
            # 设置后缀名称，跟strftime的格式一样


        except Exception:
            print('程序执行错误！！！')


    def log_config(self,family="info",content=None):
        path = "test.log"
        self.formats(level=1,path=path,time="S",index=30,file=5)

        if family == "info":
            self.info(content)
        elif family == "debug":
            self.debug(content)



    def formats(self,level=1,path=None,time="M",index=10,file=3):
        """
        :param level: 日志等级
        :param path: 文件路径
        :param time: 设置时间格式
        :param index: 时间
        :param file: 输出文件数量
        :return:
        """
        if level == 1:
            self.myapp.format1='%(asctime)s-%(filename)s-%(levelname)s:%(message)'

        if level == 2:
            self.myapp.format2 = '%(asctime)s-%(filename)s-%(levelname)s:%(message)-%(levelname)s'
        if level == 3:
            self.myapp.format3 = '%(asctime)s-%(filename)s-%(levelname)s:%(message)-%(levelname)s.%(relativeCreated)d..%(message)s'

        self.myapp.setLevel(logging.DEBUG)

        if path == None:
            path = "test.log"
        else:
            path = path
        self.timefilehandler = logging.handlers.TimedRotatingFileHandler(path, when=time, interval=index, backupCount=file)
        # 设置后缀名称，跟strftime的格式一样
        self.path = self.timefilehandler.suffix = "%Y-%m-%d_%H-%M-%S.log"
        formatter = logging.Formatter('%(asctime)s-%(filename)s-%(levelname)s:%(message)s')
        self.timefilehandler.setFormatter(formatter)
        self.myapp.addHandler(self.timefilehandler)


    def info(self,infos):
        """
        :param infos:
        :return:
        """
        try:
            self.myapp.info(infos)
        except Exception:
            print('参数输入有误！！！')

    def debug(self,debugs):
        try:
            self.myapp.debug(debugs)
        except Exception:
            print('参数输入有误！！！')

    def warning(self,war):
        try:
            self.myapp.warning(war)
        except Exception:
            print('参数输入有误！！！')

    def error(self,e):
        try:
            self.myapp.error(e)
        except Exception:
            print('参数输入有误！！！')


    def critical(self,c):
        try:
            self.myapp.critical(c)
        except Exception:
            print('参数输入有误！！！')


if __name__ == '__main__':

    Log().formats( level=1,
                 path=r"log"
    )
    Log().info("666")
