import smtplib
from email.header import Header
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart
# import email.utils


class Email:
    def __init__(self):
        pass

    def sender(self,sender=None,receiver=None):
        """
          :param sender:发件人
          :param receiver:收件人
          :return:
          """
        try:

            if sender!=None and receiver!=None:
                self.sender = sender
                self.receiver = receiver
                return [self.sender,self.receiver]
            else:
                print( "你传入的sender和receivers参数不能为空")
        except:
            print( "收信人或发件人传入失败你可以尝试修改下 sender>%s,receiver>%s"%(sender,receiver))

    def smtp(self,smtpserver='smtp.163.com'):
        """
        # 所使用的用来发送邮件的SMTP服务器
        :param smtpserver:
        :return:
        """
        if smtpserver != 'smtp.163.com':
            self.smtpserver = smtpserver
            return smtpserver
        else:
            self.smtpserver = 'smtp.163.com'
            return self.smtpserver

    def username(self,username=None,password=None):
        """
        # 发送邮箱的用户名和授权码（不是登录邮箱的密码）
        :param username:
        :param password:
        :return:
        """
        self.username = username
        self.password = password
        return self.username,self.password

    def title(self,title=None):

        self.title = title

    def example(self):

        self.message = MIMEMultipart()
        self.message['From'] = self.sender
        self.message['To'] = self.receiver
        self.message['Subject'] = Header(self.title, 'utf-8')

    def attach(self,text=None):
        # 邮件正文内容
        self.message.attach(MIMEText(text, 'plain', 'utf-8'))

    def text_format(self,path=None,filename=None):
        att1 = MIMEText(open(path, 'rb').read(), 'base64', 'utf-8')
        att1["Content-Type"] = 'application/octet-stream'
        att1["Content-Disposition"] = 'attachment; filename=%s'%filename
        self.message.attach(att1)

    def jpg_format(self,path=None):
        att2 = MIMEText(open(path, 'rb').read(), 'base64', 'utf-8')
        att2["Content-Type"] = 'application/octet-stream'
        att2["Content-Disposition"] = 'attachment; filename="123.jpg"'
        self.message.attach(att2)

    def html_format(self,path=None):
        # 构造附件3（附件为HTML格式的网页）
        att3 = MIMEText(open(path, 'rb').read(), 'base64', 'utf-8')
        att3["Content-Type"] = 'application/octet-stream'
        att3["Content-Disposition"] = 'attachment; filename="report_test.html"'
        self.message.attach(att3)

    def smtpObj(self):
        smtpObj = smtplib.SMTP()  # 注意：如果遇到发送失败的情况（提示远程主机拒接连接），这里要使用SMTP_SSL方法
        smtpObj.connect(self.smtpserver)
        smtpObj.login(self.username,self.password)

        smtpObj.sendmail(self.sender, self.receiver, self.message.as_string())

        print("邮件发送成功！！！")
        smtpObj.quit()

class Efficient_mail():

    def __init__(self, sender=None, receiver=None, smtpserver='smtp.163.com',
                 username=None, password=None, text=None, path=None, file=None,texts=None):
        """
        :param sender:  发件人
        :param receiver: 收件人
        :param smtpserver: 邮件服务端口
        :param username: 发送人名称
        :param password: 邮件密令
        :param text: 邮件标题
        :param path: 附件地址
        :param file: 文件名
        :param texts: 正文
        """
        p = Email()
        p.sender(sender, receiver)
        p.smtp(smtpserver)
        p.username(username, password)
        p.title(text)
        p.example()
        p.attach(texts)
        paths = path
        p.Text_format(path=paths, filename=file)
        p.smtpObj()


if __name__ == '__main__':
    pass



