import time,os
import logging.handlers
from config.config  import *

class LogHan:

    def __init__(self):
        # logging初始化工作
        # try:
            logging.basicConfig()
            # myapp的初始化工作
            self.myapp = logging.getLogger('myapp')
            self.myapp.format='%(asctime)s-%(filename)s-%(levelname)s:%(message)'
            self.myapp.setLevel(logging.DEBUG)
            # 添加TimedRotatingFileHandler
            # 定义一个1秒换一次log文件的handler
            # 保留3个旧log文件
            log_file_path = LOG_FILE_NAME
            print(log_file_path)

            timefilehandler = logging.handlers.TimedRotatingFileHandler(1, when='M', interval=5, backupCount=5)
            # 设置后缀名称，跟strftime的格式一样
            timefilehandler.suffix = "%Y-%m-%d_%H-%M-%S.log"

            formatter = logging.Formatter('%(asctime)s-%(filename)s-%(levelname)s:%(message)s')
            timefilehandler.setFormatter(formatter)
            self.myapp.addHandler(timefilehandler)
        # except Exception:
            print('程序执行错误！！！')

    def info(self,infos):
        """
        :param infos:
        :return:
        """
        # try:
        self.myapp.info(infos)
        # except Exception:
        #     print('参数输入有误！！！')

    def debug(self,debugs):
        try:
            self.myapp.debug(debugs)
        except Exception:
            print('参数输入有误！！！')

    def warning(self,war):
        try:
            self.myapp.warning(war)
        except Exception:
            print('参数输入有误！！！')

    def error(self,e):
        try:
            self.myapp.error(e)
        except Exception:
            print('参数输入有误！！！')


    def critical(self,c):
        try:
            self.myapp.critical(c)
        except Exception:
            print('参数输入有误！！！')


if __name__ == '__main__':
    pass
