
from common.RequestMain import RunMethod
from config.config import TEST_CASE, EXECUTE_RESULT_REPORT
from core.CommonUtil import CommonUtil
from core.DependCase import DataCaseID
from core.data import GetData



class RunTest:
	def __init__(self):
		self.run_method = RunMethod()
		self.data = GetData()
		self.common = CommonUtil()

	#程序执行的
	def run_test_case(self):
		res = None
		pass_count = []
		fail_count = []
		rows_count = self.data.get_liens()
		for i in range(1,rows_count):
			is_run = self.data.get_is_run(i)
			if is_run:
				url = self.data.get_url(i)
				method = self.data.get_request_method(i)
				request_data = self.data.get_json_for_data(i)
				is_run = self.data.get_is_run(i)
				header = self.data.get_is_headers(i)
				expected = self.data.get_expected(i)
				case = self.data.is_depend(i)

				if case !=None:
					caseID = DataCaseID(case)
					#依赖的响应数据 get_data_for_key
					request_data_case_id = caseID.get_data_for_key(i)

					depend_id_case_data = self.data.get_depend_field(i)
					#更新依赖接口数据
					request_data[depend_id_case_data] = request_data_case_id


				res = self.run_method.run_main(method=method, url=url, data=request_data, header=header)
				if EXECUTE_RESULT_REPORT == True:

					if self.common.is_contain(expected,res):
						self.data.get_write_execution_result(i, "pass")
						self.data.get_actual(i,res)
						pass_count.append(i)
					else:
						self.data.get_write_execution_result(i, "fail")
						self.data.get_actual(i,res)
						fail_count.append(i)
				else:
					if self.common.is_contain(expected,res):
						self.data.get_write_execution_result(i,"pass")
						pass_count.append(i)
					else:
						self.data.get_write_execution_result(i,"fail")
						fail_count.append(i)

				# pass_dis = len(pass_count)
				# fail_dis = len(fail_count)
				# resList = "本次测试,成功用例 %s 条,失败用例 %s 条"%(pass_count,fail_count)
				# return resList



if __name__ == '__main__':
	run = RunTest()
	run.run_test_case()



