import json

from jsonpath_rw import jsonpath,parse
from common.RequestMain import RunMethod
from config.config import TEST_CASE
from core.InterfaceDataFile import WriteExcel,JsonData
from core.data import GetData


class DataCaseID:
    def __init__(self,case_id):
        self.id = case_id
        self.data = WriteExcel(file_name=TEST_CASE)
        self.public = GetData()

    # 通过case_id去获取该case_id的整行数据
    def getID(self):
        row = self.data.get_cols_data(self.id)
        return row

    # 执行依赖测试，获取结果
    def run_dependent(self):
        run_method = RunMethod()
        row_num = self.data.get_row_num(self.id)

        request_data = self.public.get_json_for_data(row_num)

        # header = self.data.is_header(row_num)
        method = self.public.get_request_method(row_num)

        url = self.public.get_url(row_num)

        res = run_method.run_main(method, url, request_data)
        return json.loads(res)

    # 根据依赖的key去获取执行依赖测试case的响应,然后返回
    def get_data_for_key(self,row):
        depend_data = self.public.get_depend_key(row=row)

        response_data = self.run_dependent()
        if depend_data!=None:

            json_exe = parse(depend_data)
            madle = json_exe.find(response_data)
            return [math.value for math in madle]