import xlrd
from xlutils.copy import copy
import json
from config.config import TOOLS, TEST_CASE


class WriteExcel:
	def __init__(self,file_name=None,index=0):
		if file_name:
			self.file_name = file_name
		else:
			self.file_name = TOOLS
		self.data = self.get_all_data(index=index)

	#获取sheets的内容
	def get_all_data(self,index):
		data = xlrd.open_workbook(self.file_name)
		# index =
		tables = data.sheet_by_index(index)
		return tables

	#获取单元格的行数
	def get_lines(self):
		tables = self.data
		return tables.nrows

	#获取单元格的列数
	def get_cols(self):
		tables = self.data
		return tables.ncols

	#获取某一个单元格的内容
	def get_cell_value(self,row,col):
		return self.data.cell_value(row,col)

	#写入数据
	def write_value(self,row,col,value):
		'''
		写入excel数据
		row,col,value
		'''
		read_data = xlrd.open_workbook(self.file_name)
		write_data = copy(read_data)
		sheet_data = write_data.get_sheet(0)
		sheet_data.write(row,col,value)
		write_data.save(self.file_name)







	#根据对应的caseid 找到对应行的内容
	def get_case_id(self,case_id):
		row_num = self.get_row_num(case_id)
		rows_data = self.get_row_values(row_num)
		return rows_data

	#根据对应的caseid找到对应的行号
	def get_row_num(self,case_id):
		num = 0
		clols_data = self.get_cols_data()
		for col_data in clols_data:
			if case_id in col_data:
				return num
			num = num+1


	#根据行号，找到该行的内容
	def get_row_values(self,row):
		tables = self.data
		row_data = tables.row_values(row)
		return row_data

	#获取某一列的内容
	def get_cols_data(self,col_id=None):
		if col_id != None:
			cols = self.data.col_values(col_id)
		else:
			cols = self.data.col_values(0)
		return cols




class JsonData:
	def __init__(self,file_path=None):
		self.data = self.json_read(file_path=file_path)

	def json_read(self,file_path=None):
		if file_path:
			self.path = file_path
		else:
			self.path = r"Z:\My\InterfaceAutoFramework\dataFile\1.json"

		with open(self.path,"r",encoding="utf-8") as f:
			return json.load(f)


	#关键字获取数据
	def getJson_data(self,key):
		if key:
			return self.data[key]
		return None



if __name__ == '__main__':
	pass

