
"""

测试框架 配置文件
配置文件基本已全部与数据分离、无需修改配置文件内容、直接修改相应的数据文件即可。
如果需要其他内容配置可自行添加如果你有余力的话可自行修改或重构
该框架基本以满足大部分自动化测试需求。可以直接拿到项目中使用、修改相应的项目数据即可

developer: gfl
version : V1.0
"""


# Test the framework configuration file
# The configuration file has been basically separated from the data, so there is no need to modify the content of
# the configuration file and directly modify the corresponding data file.
# If you need something else you can add it if you have the resources you need you can modify it or refactor it
# The framework is basically designed to meet most of the automation test requirements.Can directly
#  get the use of the project, modify the corresponding project data can be
#

from core.Suite.enumerate import *
from core.data.ReadFileModule import *

now = time.strftime('%Y-%m-%d_%H-%M-%S', time.localtime())
# 项目路径
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))



file = os.path.abspath("").split('AutoFrame')[0]

# 测试数据文件路径
PATH_DATAFILES = [os.path.join(BASE_DIR,'data\基本配置数据.xlsx'),
                  ]

#配置路径表
path_file_index_3 = data_all(path=PATH_DATAFILES[0], index=2)


#工具数据文件路径
TOOL_DATA_PATH =os.path.join(BASE_DIR,path_file_index_3[12][1])


tool_path_1 = data_all(path=TOOL_DATA_PATH, index=0)

tool_path_2 = data_all(path=TOOL_DATA_PATH, index=1)

#测试数据配置
TEST_DATA = {
    "config":os.path.join(BASE_DIR,path_file_index_3[1][1]),
    "element": os.path.join(BASE_DIR,path_file_index_3[2][1]),
}


# 自动执行设置文件
TIME_SET_PATH = os.path.join(BASE_DIR,path_file_index_3[7][1])


time_count = read_txt(TIME_SET_PATH)


set_time = text_all(TIME_SET_PATH,1)

#UIcase 文件路径
UI_CASE_ELEMENT = os.path.join(BASE_DIR,path_file_index_3[15][1])


path_file_index = data_all(path=TEST_DATA["config"], index=0)

path_file_index_2 = data_all( path=TEST_DATA["config"], index=1)


# 项目url 地址
PHPWIND_URL={
    "front_url":path_file_index[1][2],#前端url
    "trailng_url":path_file_index[2][2],#后端url
    "login":path_file_index[3][2],#登录url
    "register":path_file_index[4][2]#注册url
}


# 测试用例脚本文件路径
TEST_CASE_PATH = {
    "casetest":os.path.join(BASE_DIR,path_file_index_3[3][1])
}


#数据库配置
DATABASES = {
    "host": tool_path_2[0][1],#服务器地址
    "user": tool_path_2[1][1],#用户名
    "password": tool_path_2[2][1],#密码
    "database": tool_path_2[3][1],#数据库名
    "port": int(tool_path_2[4][1])#数据库端口号
}



# 项目最高管理员账号
ORDER = {
    "username": path_file_index_2[1][0],
    "password": path_file_index_2[1][1]
}



# 后台管理账号
BACKGROUND = {
    "username": path_file_index_2[1][0],
    "password": path_file_index_2[1][1]

}



#设置报告样式 使用AutoFrame内置的枚举值进行切换测试报告样式 具体样式看AutoFrame技术操作手册
REPORT_STYLE = PIE

#测试报告状态
TEST_REPORT_STATE = False

#测试报告
TESTREPORT_PATH = os.path.join(BASE_DIR,path_file_index_3[4][1])

TESTREPORT_FILE_NAME = "UI自动化测试报告"

#错误截图状态  True 开启 False 关闭则不截图
SCREENSHOTS_STATE = True

#截图路径
SCREENSHOT_PATH = os.path.join(BASE_DIR,path_file_index_3[5][1])


#测试用例错误重跑次数
TEST_CASE_ERROR_RETRY = 2



#定时执行器
REGULARLY_TIME = []

#定时开关 true 开启  false 关闭
TIME_SWITCH = True

#定时启动时间
START_Time ="16:05"



#行为驱动描述文件
BEHAVIOR_DESCRIPTION = file+path_file_index_3[11][1]


#测试套件执行器路径
TEST_SUITE_PATH = os.path.join(BASE_DIR,path_file_index_3[13][1])


#浏览器驱动路径
DRIVER_PATH ={
    "chrome":os.path.join(BASE_DIR,path_file_index_3[8][1]),
    "ie":os.path.join(BASE_DIR,path_file_index_3[9][1]),
    "firefox":file+path_file_index_3[10][1],
}


#日志输出
LOG_FILE_PATH = os.path.join(BASE_DIR,path_file_index_3[6][1])

#日志输出文件名设定
LOG_FILE_NAME = os.path.join(LOG_FILE_PATH,"测试日志.log")

#日志信息输出等级 最高4级
LOG_LEVEL = 1

#日志严重等级

LOGGING_BASIC_LEVEL = DEBUG

# 日志输出文件的分割时间格式  HH:MM:SS 时-分-秒
LOGSPLIST_INTERVAL_FORMAT = "S"

# 日志输出时间 结合LOGSPLIST_INTERVAL_FORMAT 使用
LOG_OUTPUT_TIME = 5

# 分割的文件总数
BACK_UP_COUNT = 5



# Cookie存放路径
COOKIE_PATH_PUBLIC = os.path.join(BASE_DIR,path_file_index_3[14][1])

#Cookie 文件名
COOKIE_FILE_NAME = r"智联招聘Cookies.txt" #暂时只支持txt文本

#Cookie 完整路径
COOKIE_PATH = os.path.join(COOKIE_PATH_PUBLIC,COOKIE_FILE_NAME)

#Cookie URL
COOKIE_URL = "https://passport.zhaopin.com/login"



#测试报告html文件基本信息
REPORT_MESSAGES = {
    "like":"test*" ,#测试用例脚本执行条件 执行以test开头的.py脚本文件
    "title":"自动化测试报告",
    "description":"测试",
}

#自动邮件状态

EMAIL_STATE = True

#自动邮件信息文件读取
MAILBOX_INFORMATION_FILE_READ = False

#邮件配置
MAILBOX_DATA = {

"sender":{
        "username":"gfl13453001@163.com",
        "password":"gfl802300"
    },
    "title":"自动化测试执行情况汇总",
    "context":"自动化测试报告",
    "receiver":["gfl13453001@163.com","13453001@163.com"],
    "flieName":"自动化测试报告.html"
}



col_cell = col_data(col=3, path=TOOL_DATA_PATH, index=0)
col_all = col_cell[3:]

#邮件信息配置-外部文件
MAILBOX = {
    "sender":{
        "username":tool_path_1[1][0],
        "password":tool_path_1[1][1]
    },
    "receiver":
        col_all,
    "flieName":tool_path_1[5][0],
    "content":str(tool_path_1[9][0])+now,
    "title":tool_path_1[9][1]
}



#测试报告文件按时间规律存放
REPORT_FILING = True



if __name__ == '__main__':
    pass
