"""统一执行测试用例，并生成测试报告"""
import unittest,time
from core.HtmlReport.HTMLTestReportCN import HTMLTestRunner
from core.HtmlReport.HTMLTestRunner_Chart import HTMLTestRunner as htmlTest
from config.config import *


class TestSuite(object):
    def __init__(self,like,filename=None):
        #测试用例所在的路径
        self.like = like
        self.filename = filename
        self.casePath = TEST_CASE_PATH

    def test_suite(self,tester,title,description=None):
        # HTMLTestRunner:可以生成报告的执行器
        # #定义套件，将用例加入到套件中  在路径中发现(oa_开头的脚本)
        suite = unittest.defaultTestLoader.discover(TEST_CASE_PATH["casetest"],self.like)
        # #测试报告保存的路径
        Path = TESTREPORT_PATH
        now = time.strftime('%Y-%m-%d_%H-%M-%S',time.localtime())
        #测试报告的文件名
        reportName = Path+'\\%s-%s.html'%(self.filename,now)
        # 以字节写入的方式打开报告文件，效果为新建空白报告
        fp = open(reportName,'wb')
        # #定义执行器，使用能够生成报告的执行器
        runner = HTMLTestRunner(
        #     #测试过程中的数据流写入到打开的报告中
            stream=fp,tester=tester,title=title,
            description=description,
        )
        runner.run(suite)
        fp.close()  #关闭打开的文件


        return reportName

    def test_suite_chart(self,title, description=None):
        suite = unittest.defaultTestLoader.discover(TEST_CASE_PATH["casetest"], self.like)
        # #测试报告保存的路径
        Path = TESTREPORT_PATH
        now = time.strftime('%Y-%m-%d_%H-%M-%S', time.localtime())
        # 测试报告的文件名
        reportName = Path + "\\%s.html"%(TESTREPORT_FILE_NAME)
        # 以字节写入的方式打开报告文件，效果为新建空白报告
        fp = open(reportName, 'wb')
        # #定义执行器，使用能够生成报告的执行器
        runner = htmlTest(
            #     #测试过程中的数据流写入到打开的报告中
            stream=fp, retry=TEST_CASE_ERROR_RETRY, title=title,
            description=description, save_last_try=SCREENSHOTS_STATE
        )
        runner.run(suite)
        fp.close()  # 关闭打开的文件
        return reportName




