import smtplib
from email.mime.text import MIMEText
from email.mime.image import MIMEImage
from email.mime.multipart import MIMEMultipart
from email.mime.application import MIMEApplication


class Mail:
    def sender(self,sender,password,toaddrs:list,title,content=None):
        self.sender = sender
        self.password = password
        self.toaddrs = toaddrs
        self.content = content
        self.textApart = MIMEText(self.content)
        self.m = MIMEMultipart()
        self.m['Subject'] = title
        self.m.attach(MIMEText(self.content, 'plain', 'utf-8'))

    def html(self,path,filename):
        filepath = path
        htmlApart = MIMEImage(open(filepath, 'rb').read(), filepath.split('.')[-1])
        htmlApart.add_header('Content-Disposition', 'attachment', filename=filename)
        self.m.attach(htmlApart)

        return htmlApart
    def universalFile(self,path,filename):
        pdfFile = path
        pdfApart = MIMEApplication(open(pdfFile, 'rb').read())
        pdfApart.add_header('Content-Disposition', 'attachment', filename=filename)
        self.m.attach(pdfApart)

    def smtp(self,smtp='smtp.163.com'):
        try:
            server = smtplib.SMTP(smtp)
            server.login(self.sender, self.password)
            server.sendmail(self.sender, self.toaddrs, self.m.as_string())
            print('success')
            server.quit()
        except smtplib.SMTPException as e:
            print('error:', e)  # 打印错误

class UnittestMail:
    def __init__(self,sender,password,toaddrs:list,title,htmlPATH,FILEname,content=None):
        e = Mail()
        e.sender(sender=sender,password=password,toaddrs=toaddrs,title=title,content=content)
        e.html(htmlPATH,FILEname)
        # e.universalFile(r'Z:\My\AutoFrame\1.zip','1.zip')
        e.smtp()


if __name__ == '__main__':
    pass