import time,os
import logging.handlers
from config.config  import *

class Log(object):
    def __init__(self):
        # logging初始化工作
        try:
            logging.basicConfig()
            # myapp的初始化工作
            self.myapp = logging.getLogger('myapp')
            # 添加TimedRotatingFileHandler
            # 定义一个1秒换一次log文件的handler
            # 保留3个旧log文件
            # 设置后缀名称，跟strftime的格式一样
            self._format_ = None

        except Exception:
            print('程序执行错误！！！')


    def log_config(self,family="info",content=None):
        path = LOG_FILE_NAME
        self.formats(level=1)

        if family == "info":
            self.info(content)
        elif family == "debug":
            self.debug(content)



    def formats(self,level=1):
        """
        :param level: 日志等级
        :param path: 文件路径
        :param time: 设置时间格式
        :param index: 时间
        :param file: 输出文件数量
        :return:
        """

        if LOG_LEVEL == 1:

            self._format_ = '%(asctime)s\n-Script execution name %(filename)s\n-The log level: ' \
                            '%(levelname)s\n-messages- %(message)s\n'

        elif level == 2:

            self._format_ = '%(asctime)s\n-Script execution name %(filename)s \n' \
                            'module name function %(module)s \n-line of code %(lineno)d The log level: %(levelname)s  ' \
                            '\n-messages- %(message)s\n'


        elif level == 3:
            self._format_ = '%(asctime)s\n-Script execution name %(filename)s \n' \
                            'pathname of the module %(pathname)s  \n'\
                            'module name function %(module)s output time %(relativeCreated)d\n-line of code %(lineno)d The log level: %(levelname)s Level number %(levelno)s ' \
                            '\n-messages- %(message)s\n'


        elif level == 4:
            self._format_ = '%(asctime)s\n-Script execution name %(filename)s processid %(process)d\n' \
                            'pathname of the module %(pathname)s  \n' \
                            'module name function %(module)s output time %(relativeCreated)d' \
                            '\n-line of code %(lineno)d GetThreadID %(thread)d  ThreadName %(threadName)s' \
                            '\nThe log level: ' \
                            '%(levelname)s Level number %(levelno)s ' \
                            '\n-messages- %(message)s\n'


        self.myapp.setLevel(LOGGING_BASIC_LEVEL)


        # print(LOG_LEVEL)
        path = LOG_FILE_NAME
        self.timefilehandler = logging.handlers.TimedRotatingFileHandler(path, when=LOGSPLIST_INTERVAL_FORMAT, interval=LOG_OUTPUT_TIME, backupCount=BACK_UP_COUNT)
        # 设置后缀名称，跟strftime的格式一样
        self.timefilehandler.suffix = "%H-%M-%S.log"
        formatter = logging.Formatter(self._format_)
        self.timefilehandler.setFormatter(formatter)
        self.myapp.addHandler(self.timefilehandler)


    def info(self,infos):
        """
        :param infos:
        :return:11
        """
        try:
            self.myapp.info(infos)
        except Exception:
            print('参数输入有误！！！')

    def debug(self,debugs):
        try:
            self.myapp.debug(debugs)
        except Exception:
            print('参数输入有误！！！')

    def warning(self,war):
        try:
            self.myapp.warning(war)
        except Exception:
            print('参数输入有误！！！')

    def error(self,e):
        try:
            self.myapp.error(e)
        except Exception:
            print('参数输入有误！！！')


    def critical(self,c):
        try:
            self.myapp.critical(c)
        except Exception:
            print('参数输入有误！！！')

class LogOutput:
    def __init__(self,message):
        log = Log()
        log.formats(LOG_LEVEL)
        log.info(message)


if __name__ == '__main__':
    LogOutput("自动化测试")
