"""统一执行测试用例，并生成测试报告"""
import unittest,time
from adtium.report.HTMLTestReportCN import HTMLTestRunner



class TestSuite:
    def __init__(self,like,filename,casePath):
        #测试用例所在的路径
        self.like = like
        self.filename = filename
        self.casePath = casePath

    def test_suite(self,tester,title,reportpath,description=None,file_type=".py"):
        # HTMLTestRunner:可以生成报告的执行器
        suite = unittest.defaultTestLoader.discover(self.casePath[file_type],self.like)
        # #测试报告保存的路径
        Path = reportpath
        now = time.strftime('%Y-%m-%d_%H-%M-%S',time.localtime())
        #测试报告的文件名
        reportName = Path+'\\%s-%s.html'%(self.filename,now)
        # 以字节写入的方式打开报告文件，效果为新建空白报告
        fp = open(reportName,'wb')
        # #定义执行器，使用能够生成报告的执行器
        runner = HTMLTestRunner(
        #     #测试过程中的数据流写入到打开的报告中
            stream=fp,tester=tester,title=title,
            description=description
        )
        runner.run(suite)
        fp.close()  #关闭打开的文件


        return reportName







