from datetime import datetime

curr_time = datetime.now()

def current_sys_time():
    return datetime.now()


def seconds(start,stop):
    return (start-stop).seconds

#计算时间差的分钟数
# 同一天的时间差

def time_difference(a,b):
    time_1_struct = datetime.strptime(a, "%Y-%m-%d %H:%M:%S")
    time_2_struct = datetime.strptime(b, "%Y-%m-%d %H:%M:%S")
    time_ds = (time_1_struct - time_2_struct).seconds
    return   time_ds





import requests
import re
import os
import zipfile

class  VersionError(Exception):
    # 版本号获取异常
    def __init__(self, errorinfor):
        self.error = errorinfor

    def __str__(self):
        return self.error


class  MethodError(Exception):
    # 请求方式异常
    def __init__(self, errorinfor):
        self.error = errorinfor

    def __str__(self):
        return self.error


class  UrlError(Exception):
    # url输入异常
    def __init__(self, errorinfor):
        self.error = errorinfor

    def __str__(self):
        return self.error

class FilePathError(Exception):
    # 文件路径异常
    def __init__(self, errorinfor):
        self.error = errorinfor

    def __str__(self):
        return self.error



class ChromeDriver:


    def __init__(self):
        self.rep = None

    def get_version(self):
        '''查询系统内的Chromedriver版本'''
        get_system_version = os.popen('chromedriver --version').read()
        return get_system_version.split(' ')[1]


    def getDriverName(self):
        '''查询系统内的Chromedriver版本'''
        get_system_version = os.popen('chromedriver --version').read()
        return get_system_version.split(' ')[0]


    def request_txt(self,url=None):

        if url == None or url == "":
            '''查询最新的Chromedriver版本'''
            url = 'http://npm.taobao.org/mirrors/chromedriver/'
            raise MethodError("Whether you may enter the url address 你可以尝试修改 url参数值 %s"%url)

        else:

            try:
                rep = requests.get(url=url).text
                return rep

            except Exception:
                print(-1)


    def get_Latest_Version(self,url):

        response_text = self.request_txt(url='http://npm.taobao.org/mirrors/chromedriver/')

        # 用来存放版本时间
        time_list = []
        # 用来存放版本与时间对应关系
        time_version_dict = {}
        # 匹配文件夹（版本号）和时间
        result = re.compile(r'\d.*?/</a>.*?Z').findall(response_text)

        for i in result:
            # 提取时间
            time = i[-24:-1]
            # 提取版本号
            version = re.compile(r'.*?/').findall(i)[0]
            # 构建时间和版本号的对应关系，形成字典
            time_version_dict[time] = version
            # 形成时间列表
            time_list.append(time)

        # 用最大（新）时间去字典中获取最新的版本号
        latest_version_up = time_version_dict[max(time_list)][:-1]
        return latest_version_up


    def splice_address(self,SysTemType=1):
        #获取驱动器下载地址

        latest_version = self.get_Latest_Version(url='http://npm.taobao.org/mirrors/chromedriver/')

        if SysTemType==1:
            return url + latest_version + '/chromedriver_win32.zip'
        elif SysTemType ==  2:
            return url + latest_version + '/chromedriver_linux32.zip'
        else:
            return url + latest_version + '/chromedriver_mac64.zip'

    def get_driver_path(self):
        '''查询系统内Chromedriver的存放路径'''
        getDriverPath = os.popen('where chromedriver').read()
        return getDriverPath.strip('chromedriver.exe\n')



    def download_driver(self,path=None,SysTemType=1):
        #判断输入的文件夹或路径是否真实存在


        self.fileNamePath = ''
        filepath = os.path.exists(path)
        if path == None or filepath == False:
            self.fileNamePath = 'chromedriver.zip'

            raise FilePathError("The downloaded file path is not entered or the path is wrong 你可以尝试修改文件路径参数path %s"%path)
        else:

            path_url = self.splice_address(SysTemType=SysTemType)
            '''下载文件'''
            file = requests.get(url=path_url)
            self.fileNamePath = path

            # path_file = path+r"\%s"%fileName
            # 保存文件到脚本所在目录
            with open(self.fileNamePath, 'wb') as zip_file:
                zip_file.write(file.content)
                print('下载成功')


    def unzip_driver_public(self,path,file):
        '''解压Chromedriver压缩包到指定目录'''
        f = zipfile.ZipFile(file,'r')
        for files in f.namelist():
            f.extract(files, path)



    def Update_download(self,fileNamePath="chromedriver1.zip",sys_type=1):
        #获取最新的driver并解压放置python目录下
        self.fileNamePath = fileNamePath
        latest_version_int = self.get_Latest_Version(url='http://npm.taobao.org/mirrors/chromedriver/')
        print("目前最新的chromedriver版本为",latest_version_int)

        sys_version = self.get_version()
        print("目前系统的chromedriver版本为",sys_version)

        if sys_version == latest_version_int:
            print('当前系统内的Chromedriver已经是最新的')
        else:
            print('当前系统内的Chromedriver不是最新的，需要进行更新')
            download_path_url = self.splice_address(SysTemType=sys_type)

            file = requests.get(url=download_path_url)

            print('正在为你下载最新版chromedriver：', download_path_url)

            with open(self.fileNamePath,'wb') as zip_file:
                zip_file.write(file.content)
                print('下载成功')


            dir_path = os.path.abspath('.')+r'\%s'%fileNamePath
            print(dir_path)

            print('正在为你解压chromedriver并放置新的位置', download_path_url)

            driver_path = self.get_driver_path()

            self.unzip_driver_public(path=driver_path,file=dir_path)

            driver_path = self.get_driver_path()

            print('chromedriver存放位置于', driver_path)

            print('更新后的Chromedriver版本为：', self.get_version())



if __name__ == "__main__":
    url = 'http://npm.taobao.org/mirrors/chromedriver/'
    c = ChromeDriver()
    p = c.Update_download()
    #









